ojph Namespace Reference

## Namespaces

namespace | local

## Classes

class | bibo_gains
struct | coded_lists
struct | line_buf
class | mem_elastic_allocator
class | mem_fixed_allocator
class | message_base
class | message_error
class | message_info
class | message_warning
struct | QuantizerOJPH
class | RoiScaleOJPHFilter
class | RoiShiftOJPHFilter
class | ScaleOJPHFilter
class | ShiftOJPHFilter
class | sqrt_energy_gains
class | T1OJPH

## Typedefs

typedef uint8_t | ui8
typedef int8_t | si8
typedef uint16_t | ui16
typedef int16_t | si16
typedef uint32_t | ui32
typedef int32_t | si32
typedef uint64_t | ui64
typedef int64_t | si64

## Enumerations

enum | : int { X86_CPU_EXT_LEVEL_GENERIC = 0 , X86_CPU_EXT_LEVEL_MMX = 1 , X86_CPU_EXT_LEVEL_SSE = 2 , X86_CPU_EXT_LEVEL_SSE2 = 3 , X86_CPU_EXT_LEVEL_SSE3 = 4 , X86_CPU_EXT_LEVEL_SSSE3 = 5 , X86_CPU_EXT_LEVEL_SSE41 = 6 , X86_CPU_EXT_LEVEL_SSE42 = 7 , X86_CPU_EXT_LEVEL_AVX = 8 , X86_CPU_EXT_LEVEL_AVX2 = 9 , X86_CPU_EXT_LEVEL_AVX2FMA = 10 , X86_CPU_EXT_LEVEL_AVX512 = 11 }
enum | OJPH_MSG_LEVEL : int { NO_MSG = 0 , INFO = 1 , WARN = 2 , ERROR = 3 }

## Functions

OJPH_EXPORT int | get_cpu_ext_level ()
static ui32 | population_count (ui32 val)
static ui32 | count_leading_zeros (ui32 val)
static ui32 | count_trailing_zeros (ui32 val)
static si32 | ojph_round (float val)
static si32 | ojph_trunc (float val)
template<typename T , int N>
size_t | calc_aligned_size (size_t size)
template<typename T , int N>
T * | align_ptr (T *ptr)
OJPH_EXPORT void | set_info_stream (FILE *s)
OJPH_EXPORT void | configure_info (message_info *info)
OJPH_EXPORT message_info & | get_info ()
OJPH_EXPORT void | set_warning_stream (FILE *s)
OJPH_EXPORT void | configure_warning (message_warning *warn)
OJPH_EXPORT message_warning & | get_warning ()
OJPH_EXPORT void | set_error_stream (FILE *s)
OJPH_EXPORT void | configure_error (message_error *error)
OJPH_EXPORT message_error & | get_error ()

## Variables

const ui32 | byte_alignment = 32
const ui32 | log_byte_alignment = 31 - count_leading_zeros(byte_alignment)
const ui32 | object_alignment = 8
const int | NUM_FRAC_BITS = 13

## Typedef Documentation

## si16

typedef int16_t ojph::si16

## si32

typedef int32_t ojph::si32

## si64

typedef int64_t ojph::si64

## si8

typedef int8_t ojph::si8

## ui16

typedef uint16_t ojph::ui16

## ui32

typedef uint32_t ojph::ui32

## ui64

typedef uint64_t ojph::ui64

## ui8

typedef uint8_t ojph::ui8

## Enumeration Type Documentation

## anonymous enum

anonymous enum : int

Enumerator
X86_CPU_EXT_LEVEL_GENERIC |
X86_CPU_EXT_LEVEL_MMX |
X86_CPU_EXT_LEVEL_SSE |
X86_CPU_EXT_LEVEL_SSE2 |
X86_CPU_EXT_LEVEL_SSE3 |
X86_CPU_EXT_LEVEL_SSSE3 |
X86_CPU_EXT_LEVEL_SSE41 |
X86_CPU_EXT_LEVEL_SSE42 |
X86_CPU_EXT_LEVEL_AVX |
X86_CPU_EXT_LEVEL_AVX2 |
X86_CPU_EXT_LEVEL_AVX2FMA |
X86_CPU_EXT_LEVEL_AVX512 |

## OJPH_MSG_LEVEL

enum ojph::OJPH_MSG_LEVEL : int

Enumerator
NO_MSG |
INFO |
WARN |
ERROR |

## Function Documentation

## align_ptr()

template<typename T , int N>

T * ojph::align_ptr | ( | T * | ptr | ) |

inline

References count_leading_zeros().

## calc_aligned_size()

template<typename T , int N>

size_t ojph::calc_aligned_size | ( | size_t | size | ) |

References count_leading_zeros().

## configure_error()

OJPH_EXPORT void ojph::configure_error | ( | message_error * | error | ) |

## configure_info()

OJPH_EXPORT void ojph::configure_info | ( | message_info * | info | ) |

## configure_warning()

OJPH_EXPORT void ojph::configure_warning | ( | message_warning * | warn | ) |

## count_leading_zeros()

static ui32 ojph::count_leading_zeros | ( | ui32 | val | ) |

inline static

References population_count().

Referenced by align_ptr(), calc_aligned_size(), ojph::local::frwd_read(), ojph::local::ojph_decode_codeblock(), and ojph::local::ojph_encode_codeblock().

## count_trailing_zeros()

static ui32 ojph::count_trailing_zeros | ( | ui32 | val | ) |

inline static

References population_count().

## get_cpu_ext_level()

OJPH_EXPORT int ojph::get_cpu_ext_level | ( |  | ) |

## get_error()

OJPH_EXPORT message_error & ojph::get_error | ( |  | ) |

## get_info()

OJPH_EXPORT message_info & ojph::get_info | ( |  | ) |

## get_warning()

OJPH_EXPORT message_warning & ojph::get_warning | ( |  | ) |

## ojph_round()

static si32 ojph::ojph_round | ( | float | val | ) |

inline static

## ojph_trunc()

static si32 ojph::ojph_trunc | ( | float | val | ) |

inline static

## population_count()

static ui32 ojph::population_count | ( | ui32 | val | ) |

inline static

Referenced by count_leading_zeros(), count_trailing_zeros(), ojph::local::ojph_decode_codeblock(), and ojph::local::vlc_init_tables().

## set_error_stream()

OJPH_EXPORT void ojph::set_error_stream | ( | FILE * | s | ) |

## set_info_stream()

OJPH_EXPORT void ojph::set_info_stream | ( | FILE * | s | ) |

## set_warning_stream()

OJPH_EXPORT void ojph::set_warning_stream | ( | FILE * | s | ) |

## Variable Documentation

## byte_alignment

const ui32 ojph::byte_alignment = 32

## log_byte_alignment

const ui32 ojph::log_byte_alignment = 31 - count_leading_zeros(byte_alignment)

## NUM_FRAC_BITS

const int ojph::NUM_FRAC_BITS = 13

## object_alignment

const ui32 ojph::object_alignment = 8